/*
    Scsign 
    Copyleft (C) 2004 Antonino Iacono

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
** include functions from
** Copyright (C) 1995-1998 Eric Young (eay@cryptsoft.com)
**
** include functions from 
** OpenSC (www.opensc.org).
**
** Thanks And Credits to Diska (discardin@tiscali.it)
*/

#include "scsign.h"

char *file_certificato = "/tmp/certi_temp";
char *opt_pincode = NULL;
char* certificato = NULL;

int main(int argc, char *argv[])
        {
        char **args;
	int badarg, okarg;
	int operation;
	char* in;

        args = argv + 1;
        args = argv + 1;

	badarg=0;
	okarg=0;

        while (!badarg && *args) {

               if (!strcmp (*args, "listcert")) operation = 1;
                else if (!strcmp (*args, "sign")) operation = 2;
                else if (!strcmp (*args, "-in")) {
                        if (args[1]) {
                                args++;
	                        in = *args;
				okarg += 1;
                        } else badarg = 1;
                } else if (!strcmp (*args, "-signer")) {
                        if (args[1]) {
                                args++;
	                        certificato = *args;
				okarg += 5;    
                    } else badarg = 1;
                }  else if (!strcmp (*args, "-pin")) {
                        if (args[1]) {
                                args++;
	                        opt_pincode = *args;
				okarg += 85;
                        } else badarg = 1;
                } else badarg = 1;
                args++;
        }

 if (badarg || argc < 2 || (operation == 2 && okarg!=91 ))
 {
 printf("%s","\nusage: scsign [commands] [args]\n\n");
 printf("%s","commands:\n\n");
 printf("%s"," sign <args>		  make a signature\n");
 printf("%s"," listcert		  list certificates\n\n");
 printf("%s","args:\n\n -signer <arg>		  ID certificate \n -in <arg>		  input file \n -pin <arg>		  password smart card \n\n");
 return 1;
 }


#ifdef WIN32
strcpy(file_certificato,getenv("TEMP")); 
strcat(file_certificato,"\\certi_temp");
#endif


if (operation==1) p15getlistcert();
else if (operation==2)
{
	if (p15getcert(certificato)) return 1;

	mysign(in,file_certificato);


}
return 0;

}

